Package com.ngrok.services

# Class TunnelSessions

java.lang.Object
com.ngrok.services.TunnelSessions

public class TunnelSessions extends Object
Tunnel Sessions represent instances of ngrok agents or SSH reverse tunnel sessions that are running and connected to the ngrok service. Each tunnel session can include one or more Tunnels. See also https://ngrok.com/docs/api#api-tunnel-sessions.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `class`
  `TunnelSessions.GetCallBuilder`
  A builder object encapsulating state for an unsent Get API call.
  `class`
  `TunnelSessions.ListCallBuilder`
  A builder object encapsulating state for an unsent List API call.
  `class`
  `TunnelSessions.RestartCallBuilder`
  A builder object encapsulating state for an unsent Restart API call.
  `class`
  `TunnelSessions.StopCallBuilder`
  A builder object encapsulating state for an unsent Stop API call.
  `class`
  `TunnelSessions.UpdateCallBuilder`
  A builder object encapsulating state for an unsent Update API call.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TunnelSessions(NgrokApiClient apiClient)`
  Creates a new sub-client for TunnelSessions.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `TunnelSessions.GetCallBuilder`
  `get(String id)`
  Get the detailed status of a tunnel session by ID See also https://ngrok.com/docs/api#api-tunnel-sessions-get.
  `TunnelSessions.ListCallBuilder`
  `list()`
  List all online tunnel sessions running on this account.
  `TunnelSessions.RestartCallBuilder`
  `restart(String id)`
  Issues a command instructing the ngrok agent to restart.
  `TunnelSessions.StopCallBuilder`
  `stop(String id)`
  Issues a command instructing the ngrok agent that started this tunnel session to exit.
  `TunnelSessions.UpdateCallBuilder`
  `update(String id)`
  Issues a command instructing the ngrok agent to update itself to the latest version.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TunnelSessions

    public TunnelSessions(NgrokApiClient apiClient)
    Creates a new sub-client for TunnelSessions.
    Parameters:
      `apiClient` - an instance of `NgrokApiClient`

- ## Method Details

  - ### list

    public TunnelSessions.ListCallBuilder list()
    List all online tunnel sessions running on this account. See also https://ngrok.com/docs/api#api-tunnel-sessions-list.
    Returns:
      a call builder for this API call

  - ### get

    public TunnelSessions.GetCallBuilder get(String id)
    Get the detailed status of a tunnel session by ID See also https://ngrok.com/docs/api#api-tunnel-sessions-get.
    Parameters:
      `id` - a resource identifier
    Returns:
      a call builder for this API call

  - ### restart

    public TunnelSessions.RestartCallBuilder restart(String id)
    Issues a command instructing the ngrok agent to restart. The agent restarts itself by calling exec() on platforms that support it. This operation is notably not supported on Windows. When an agent restarts, it reconnects with a new tunnel session ID. See also https://ngrok.com/docs/api#api-tunnel-sessions-restart.
    Parameters:
      `id` - a resource identifier
    Returns:
      a call builder for this API call

  - ### stop

    public TunnelSessions.StopCallBuilder stop(String id)
    Issues a command instructing the ngrok agent that started this tunnel session to exit. See also https://ngrok.com/docs/api#api-tunnel-sessions-stop.
    Parameters:
      `id` - a resource identifier
    Returns:
      a call builder for this API call

  - ### update

    public TunnelSessions.UpdateCallBuilder update(String id)
    Issues a command instructing the ngrok agent to update itself to the latest version. After this call completes successfully, the ngrok agent will be in the update process. A caller should wait some amount of time to allow the update to complete (at least 10 seconds) before making a call to the Restart endpoint to request that the agent restart itself to start using the new code. This call will never update an ngrok agent to a new major version which could cause breaking compatibility issues. If you wish to update to a new major version, that must be done manually. Still, please be aware that updating your ngrok agent could break your integration. This call will fail in any of the following circumstances: there is no update available the ngrok agent's configuration disabled update checks the agent is currently in process of updating the agent has already successfully updated but has not yet been restarted See also https://ngrok.com/docs/api#api-tunnel-sessions-update.
    Parameters:
      `id` - the value of the `id` parameter as a `String`
    Returns:
      a call builder for this API call